#!/bin/sh -efu

. install2-init-functions

[ -z "$AUTOINSTALL" ] || exit 0

read_ldap()
{
    local name="$1";shift
    
    sed -nr "s,^$name[[:space:]]+,,p" $destdir/etc/openldap/slapd-hpc-user.conf |
	sed -e 's,^",,' -e 's,"$,,'
}

read_hostname()
{
    exec_chroot hostname
}

read_storage()
{
    sed -nr 's,^[[:space:]]*([^[:space:]]+)[[:space:]]+/home[[:space:]]+.*,\1,p' $destdir/etc/fstab
}

function tune_profile()
{
    local mkaidir="$1";shift
    local autoinstall_conf="$mkaidir/autoinstall.scm"
    local pxelinux_conf="$mkaidir/pxelinux.cfg"

    [ ! -f "$autoinstall_conf" ] ||
        sed -r -e "s/@HOSTNAME@/$H/g" \
	       -e "s/@BASEDN@/$B/g" \
	       -e "s,@STORAGE@,$S,g" \
	       -i "$autoinstall_conf"
    [ ! -f "$pxelinux_conf" ] ||
	sed -r "s/@HOSTNAME@/$H/" -i "$pxelinux_conf"
}


B="$(read_ldap suffix)"
R="$(read_ldap rootdn)"
H="$(read_hostname)"
S="$(read_storage)"

#pam_ldap/nss_ldap tuning
run_chroot alterator-cmdline "/auth" action "write" profile "ldap" ldap_uri "ldap://$H" ldap_basedn "$B"
run_chroot alterator-cmdline "/nsswitch" action "write" profile "ldap" ldap_uri "ldap://$H" ldap_basedn "$B"

#profiles
tune_profile "$destdir/etc/mkai/profiles/sample"
tune_profile "$destdir/etc/mknfsroot/profiles/sample"

#mknfsroot sample
mkaidir="$destdir/etc/mkai/profiles/sample/"
autoinstall_conf="$mkaidir/autoinstall.scm"
pxelinux_conf="$mkaidir/pxelinux.cfg"


#cl-user-tools
cluser_conf="$destdir/etc/cl-user.conf"

if [ -f "$cluser_conf" ];then
cat >"$cluser_conf"<<EOF
dn="$B"
binddn="$R"
uid_min=700
gid_min=700
EOF
fi
